module Rockpaperscissors123
  class Game
    attr_reader :moves, :players

    def initialize(args = {})
      @moves = ["rock", "paper", "scissors"]
      @players = args[:players]
    end

    def play
      players.each { |player| player.decide_move }
      validate_moves(players)
      render_outcome(players)
    end

    def validate_moves(players)
      players.each do |player|
        player.decide_move unless validate_move(player.move)
      end
    end

    def validate_move(move)
      moves.include?(move)
    end

    def render_outcome(players)
      puts determine_outcome(players)
      puts "Player one threw: #{ players[0].move } | Player two threw: #{ players[1].move }"
    end

    def determine_outcome(players)
      if players[0].move == players[1].move
        "Tie"
      else
        determine_winner(players)
      end
    end

    def determine_winner(players)
      outcomes = {  ["paper", "rock"]    => "Player one wins",
                    ["scissors", "paper"] => "Player one wins",
                    ["rock", "scissors"] => "Player one wins"
                  }
      outcomes[[players[0].move, players[1].move]] || "Player two wins"
    end
  end
end
